/*
 * Copyright (C) 2003-2015 eXo Platform SAS.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
package org.exoplatform.cs.integration.notification;


import org.exoplatform.commons.api.notification.NotificationContext;
import org.exoplatform.commons.api.notification.model.ArgumentLiteral;
import org.exoplatform.commons.api.notification.model.NotificationInfo;
import org.exoplatform.commons.api.notification.plugin.BaseNotificationPlugin;
import org.exoplatform.commons.utils.CommonsUtils;
import org.exoplatform.container.xml.InitParams;
import org.exoplatform.cs.entity.LogEntity;
import org.exoplatform.cs.entity.TopicEntity;
import org.exoplatform.services.log.ExoLogger;
import org.exoplatform.services.log.Log;
import org.exoplatform.social.core.manager.IdentityManager;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.Set;


public class CSTicketAssignedToMeNotificationPlugin extends BaseNotificationPlugin {


  private static final Log LOG = ExoLogger.getLogger(CSTicketAssignedToMeNotificationPlugin.class);

  public final static String ID = "CSTicketAssignedToMeNotificationPlugin";


  public final static ArgumentLiteral<TopicEntity> TICKET = new ArgumentLiteral<TopicEntity>(TopicEntity.class, "ticket");
  public final static ArgumentLiteral<LogEntity> LOG_ENTITY = new ArgumentLiteral<LogEntity>(LogEntity.class, "logEntity");




  IdentityManager identityManager;

  public CSTicketAssignedToMeNotificationPlugin(InitParams initParams, IdentityManager identityManager) {

    super(initParams);
    this.identityManager = identityManager;

  }



  @Override

  public String getId() {

    return ID;

  }



  @Override

  public boolean isValid(NotificationContext ctx) {

    return true;

  }




  @Override

  protected NotificationInfo makeNotification(NotificationContext ctx) {

    TopicEntity ticket = ctx.value(TICKET);
    LogEntity logEntity = ctx.value(LOG_ENTITY);
    Set<String> receivers = new HashSet<String>();
    receivers.add(ticket.getAssignee());
    StringBuilder activityId = new StringBuilder(logEntity.getUserID());
    activityId.append("-").append(ticket.getId());
    String ticketUrl = CommonsUtils.getCurrentDomain()+ticket.getLink();
    String ticketId = ticket.getTicketId();
    String ticketTitle = ticket.getTitle();

    return NotificationInfo.instance()

            .setFrom(logEntity.getUserID())
            .to(new LinkedList<String>(receivers))
            .with(NotificationUtils.CREATOR, logEntity.getUserID())
            .with(NotificationUtils.USER_NAME, logEntity.getUserID())
            .with(NotificationUtils.TICKET_URL, ticketUrl)
            .with(NotificationUtils.TICKET_ID, ticketId)
            .with(NotificationUtils.TICKET_TITLE, ticketTitle)
            .with(NotificationUtils.ACTIVITY_ID, activityId.toString())
            .key(getKey()).end();

  }
}